<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Task 49.10</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
</head>
<body class="hold-transition sidebar-mini" onload="onPageLoading()">
<!-- Site wrapper -->
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="index3.html" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Orders</a>
      </li>
    </ul>

  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">Pizza 365</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">uyendtn</a>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="index.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Orders</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="index2.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Vouchers</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="index3.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Drink list</p>
                </a>
              </li>
            </ul>
          </li>
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Danh sách đơn hàng</h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Orders</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    
      <!-- Order Data Table -->
      <div class="container">
          <div class="jumbotron container">
              <div class="row form-group">
                <div class="col-sm-2 text-right">
                  <label  >Loại Pizza</label>
                </div>
                <div class="col-sm-4">
                  <select id="gPizzaTypeSelect" class="form-control">
          
                  </select>
                </div>
                <div class="col-sm-2 text-right">
                  <label >Trạng thái</label>
                </div>
                <div class="col-sm-4">
                  <select id="gStatusSelect" class="form-control">
          
                  </select>
                </div>
              </div>
                <div class="text-right">
                  <button id="btn-filter-order" class="btn btn-info">Lọc dữ liệu</button>
                </div>
              
          </div>
          <input type="button" class="btn btn-success form-group" value="Thêm Order" id="btn-add-order" data-toggle='modal' data-target='#insert-order-modal'> 
          <table class="table table-bordered table-striped table-hover text-center" id="order-table">
              <thead>
              <tr>
                  <th>Order ID</th>
                  <th>Loại pizza</th>
                  <th>Kích cỡ</th>
                  <th>Loại nước uống</th>
                  <th>Mã voucher</th>
                  <th>Thành tiền</th>
                  <th>Họ tên</th>
                  <th>Số điện thoại</th>
                  <th>Địa chỉ</th>
                  <th>Lời nhắn</th>
                  <th>Trạng thái</th>
                  <th>Action</th>
              </tr>
              </thead>
              <tbody>
              </tbody>
          </table>
      </div>
      <!-- Vùng Modal -->
  
      <!-- Create order modal -->
      <div id="create-order-modal" class="modal fade" tabindex="-1">
          <div class="modal-dialog">
              <div class="modal-content">
                  <div class="modal-header text-center">
                      <h5 class="modal-title ">Chi tiết đơn hàng</h5>
                      <button type="button" class="close" data-dismiss="modal">&times;</button>
                  </div>
                  <div class="modal-body">
                      <form>
                          <div class="row form-group mx-auto">
                              <label class="col-sm-4 text-right">Kích cỡ:</label>
                              <div class="w-50">
                                  <select class="col-sm-8 form-control " type="text" id="add-select-kich-co" onchange="assignValueBaseOnCombo(this.value);" >
                                      
                                  </select>
                              </div>
                          </div>
                          <div class="row form-group mx-auto">
                              <label class="col-sm-4 text-right">Đường kính:</label>
                              <div class="w-50">
                                  <input class="col-sm-8 form-control " type="text" id="add-inp-duong-kinh" readonly="readonly" >
                              </div>
                          </div>
                          <div class="row form-group mx-auto">
                              <label class="col-sm-4 text-right">Sườn:</label>
                              <div class="w-50">
                                  <input class="col-sm-8 form-control " type="text" id="add-inp-suon-nuong" readonly="readonly">
                              </div>
                          </div>
                          <div class="row form-group mx-auto">
                              <label class="col-sm-4 text-right">Salad:</label>
                              <div class="w-50">
                                  <input class="col-sm-8 form-control " type="text" id="add-inp-salad" readonly="readonly">
                              </div>
                          </div>
                          <div class="row form-group mx-auto">
                              <label class="col-sm-4 text-right">Số lượng nước:</label>
                              <div class="w-50">
                                  <input class="col-sm-8 form-control " type="text" id="add-inp-so-luong-nuoc" readonly="readonly">
                              </div>
                          </div>
                          <div class="row form-group mx-auto">
                              <label class="col-sm-4 text-right">Đơn giá:</label>
                              <div class="w-50">
                                  <input class="col-sm-8 form-control " type="text" id="add-inp-don-gia" readonly="readonly">
                              </div>
                          </div>
                          <div class="row form-group mx-auto">
                              <label class="col-sm-4 text-right">Loại pizza:</label>
                              <div class="w-50">
                                  <select class="col-sm-8 form-control " type="text" id="add-select-loai-pizza" >
                                      
                                  </select>
                              </div>
                          </div>
                          <div class="row form-group mx-auto">
                              <label class="col-sm-4 text-right">Voucher ID:</label>
                              <div class="w-50">
                                  <input class="col-sm-8 form-control " type="text" id="add-inp-voucher-id" >
                              </div>
                          </div>
                          <div class="row form-group mx-auto">
                              <label class="col-sm-4 text-right">Loại nước uống:</label>
                              <div class="w-50">
                                  <select class="col-sm-8 form-control " type="text" id="add-select-nuoc-uong" >
                                      <option value="NOT_SELECT_DRINK">Chọn loại nước uống</option>
                                  </select>
                              </div>
                          </div>
                          <div class="row form-group mx-auto">
                              <label class="col-sm-4 text-right">Họ và tên:</label>
                              <div class="w-50">
                                  <input class="col-sm-8 form-control " type="text" id="add-inp-ho-ten" >
                              </div>
                          </div>
                          <div class="row form-group mx-auto">
                              <label class="col-sm-4 text-right">Số điện thoại:</label>
                              <div class="w-50">
                                  <input class="col-sm-8 form-control " type="text" id="add-inp-so-dien-thoai" >
                              </div>
                          </div>
                          <div class="row form-group mx-auto">
                              <label class="col-sm-4 text-right">Địa chỉ:</label>
                              <div class="w-50">
                                  <input class="col-sm-8 form-control " type="text" id="add-inp-dia-chi" >
                              </div>
                          </div>
                          <div class="row form-group mx-auto">
                              <label class="col-sm-4 text-right">Email:</label>
                              <div class="w-50">
                                  <input class="col-sm-8 form-control " type="text" id="add-inp-email" >
                              </div>
                          </div>
                          <div class="row form-group mx-auto">
                              <label class="col-sm-4 text-right">Lời nhắn:</label>
                              <div class="w-50">
                                  <input class="col-sm-8 form-control " type="text" id="add-inp-loi-nhan" >
                              </div>
                          </div>
                          <div class="row form-group mx-auto">
                              <label class="col-sm-4 text-right">Trạng thái:</label>
                              <div class="w-50">
                                  <select class="col-sm-8 form-control " type="text" id="add-select-trang-thai" >
                                      
                                  </select>
                              </div>
                          </div>
                      </form>
                      <div class="row form-group justify-content-center">
                          <button class="btn btn-success mx-1" id="btn-create-order">Create</button>
                          <button class="btn btn-secondary mx-1" id="btn-create-cancel" data-dismiss="modal">Cancel</button>
                      </div>
                  </div>
              </div>
          </div>
      </div>
      <!-- Vùng Modal -->
  
      <!-- Update order modal -->
      <div id="update-order-modal" class="modal fade" tabindex="-1">
          <div class="modal-dialog">
              <div class="modal-content">
                  <div class="modal-header">
                      <h5 class="modal-title text-center">Update đơn hàng</h5>
                      <button type="button" class="close" data-dismiss="modal">&times;</button>
                  </div>
                  <div class="modal-body">
                      <form>
                          <div class="row form-group mx-auto">
                              <label class="col-sm-4 text-right">Order ID:</label>
                              <div class="w-50">
                                  <input class="col-sm-8 form-control " type="text" id="update-inp-order-id" readonly="readonly">
                              </div>
                          </div>
                          <div class="row form-group mx-auto">
                              <label class="col-sm-4 text-right">Kích cỡ:</label>
                              <div class="w-50">
                                  <select class="col-sm-8 form-control " type="text" id="update-select-kich-co" readonly="readonly">
                                      
                                  </select>
                              </div>
                          </div>
                          <div class="row form-group mx-auto">
                              <label class="col-sm-4 text-right">Đường kính:</label>
                              <div class="w-50">
                                  <input class="col-sm-8 form-control " type="text" id="update-inp-duong-kinh" readonly="readonly">
                              </div>
                          </div>
                          <div class="row form-group mx-auto">
                              <label class="col-sm-4 text-right">Sườn:</label>
                              <div class="w-50">
                                  <input class="col-sm-8 form-control " type="text" id="update-inp-suon-nuong" readonly="readonly">
                              </div>
                          </div>
                          <div class="row form-group mx-auto">
                              <label class="col-sm-4 text-right">Salad:</label>
                              <div class="w-50">
                                  <input class="col-sm-8 form-control " type="text" id="update-inp-salad" readonly="readonly">
                              </div>
                          </div>
                          <div class="row form-group mx-auto">
                              <label class="col-sm-4 text-right">Số lượng nước:</label>
                              <div class="w-50">
                                  <input class="col-sm-8 form-control " type="text" id="update-inp-so-luong-nuoc" readonly="readonly">
                              </div>
                          </div>
                          <div class="row form-group mx-auto">
                              <label class="col-sm-4 text-right">Đơn giá:</label>
                              <div class="w-50">
                                  <input class="col-sm-8 form-control " type="text" id="update-inp-don-gia" readonly="readonly">
                              </div>
                          </div>
                          <div class="row form-group mx-auto">
                              <label class="col-sm-4 text-right">Loại pizza:</label>
                              <div class="w-50">
                                  <select class="col-sm-8 form-control " type="text" id="update-select-loai-pizza" readonly="readonly">
                                      
                                  </select>
                              </div>
                          </div>
                          <div class="row form-group mx-auto">
                              <label class="col-sm-4 text-right">Voucher ID:</label>
                              <div class="w-50">
                                  <input class="col-sm-8 form-control " type="text" id="update-inp-voucher-id" readonly="readonly">
                              </div>
                          </div>
                          <div class="row form-group mx-auto">
                              <label class="col-sm-4 text-right">Thành tiền:</label>
                              <div class="w-50">
                                  <input class="col-sm-8 form-control " type="text" id="update-inp-thanh-tien" readonly="readonly">
                              </div>
                          </div>
                          <div class="row form-group mx-auto">
                              <label class="col-sm-4 text-right">Loại nước uống:</label>
                              <div class="w-50">
                                  <select class="col-sm-8 form-control " type="text" id="update-select-nuoc-uong" readonly="readonly">
                                      <option value="NOT_SELECT_DRINK">Chọn loại nước uống</option>
                                  </select>
                              </div>
                          </div>
                          <div class="row form-group mx-auto">
                              <label class="col-sm-4 text-right">Họ và tên:</label>
                              <div class="w-50">
                                  <input class="col-sm-8 form-control " type="text" id="update-inp-ho-ten" readonly="readonly">
                              </div>
                          </div>
                          <div class="row form-group mx-auto">
                              <label class="col-sm-4 text-right">Số điện thoại:</label>
                              <div class="w-50">
                                  <input class="col-sm-8 form-control " type="text" id="update-inp-so-dien-thoai" readonly="readonly">
                              </div>
                          </div>
                          <div class="row form-group mx-auto">
                              <label class="col-sm-4 text-right">Địa chỉ:</label>
                              <div class="w-50">
                                  <input class="col-sm-8 form-control " type="text" id="update-inp-dia-chi" readonly="readonly">
                              </div>
                          </div>
                          <div class="row form-group mx-auto">
                              <label class="col-sm-4 text-right">Email:</label>
                              <div class="w-50">
                                  <input class="col-sm-8 form-control " type="text" id="update-inp-email" readonly="readonly">
                              </div>
                          </div>
                          <div class="row form-group mx-auto">
                              <label class="col-sm-4 text-right">Lời nhắn:</label>
                              <div class="w-50">
                                  <input class="col-sm-8 form-control " type="text" id="update-inp-loi-nhan" readonly="readonly">
                              </div>
                          </div>
                          <div class="row form-group mx-auto">
                              <label class="col-sm-4 text-right">Trạng thái:</label>
                              <div class="w-50">
                                  <select class="col-sm-8 form-control " type="text" id="update-select-trang-thai" >
                                      
                                  </select>
                              </div>
                          </div>
                      </form>
                      <div class="row form-group justify-content-center">
                          <button class="btn btn-success mx-1" id="btn-update-order">Update</button>
                          <button class="btn btn-secondary mx-1" data-dismiss="modal">Cancel</button>
                      </div>
                  </div>
              </div>
          </div>
      </div>
      <!-- Vùng Modal -->
  
      <!-- Delete confirm modal -->
      <div id="delete-order-modal" class="modal fade" tabindex="-1">
          <div class="modal-dialog">
              <div class="modal-content">
                  <div class="modal-header">
                      <h5 class="modal-title">Confirm xóa đơn hàng</h5>
                      <button type="button" class="close" data-dismiss="modal">&times;</button>
                  </div>
                  <div class="modal-body"> 
                      <p>Bạn có chắc chắn muốn xóa đơn hàng này không?</p>
                  </div>
                  <div class="modal-footer">
                      <button class="btn btn-danger" id="btn-confirm-delete-order">Confirm</button>
                      <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                  </div>
              </div>
          </div>
      </div>
      <!-- Vùng Modal -->
  
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  <br>
  <footer class="main-footer">
    <div class="float-right d-none d-sm-block">
      <b>Version</b> 3.2.0
    </div>
    <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">Pizza 365</a>.</strong> All rights reserved.
  </footer>

  <!-- Control Sidebar -->
  <aside class="control-sidebar control-sidebar-dark">
    <!-- Control sidebar content goes here -->
  </aside>
  <!-- /.control-sidebar -->
</div>
<!-- ./wrapper -->
</body>
<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.min.js"></script>
<!-- AdminLTE for demo purposes -->
<script src="dist/js/demo.js"></script>

<script>
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
  const gCOLUMN_ORDER_ID = 0;
  const gCOLUMN_PIZZA_TYPE = 1;
  const gCOLUMN_COMBO_SIZE = 2;
  const gCOLUMN_DRINK = 3;
  const gCOLUMN_VOUCHER_ID = 4;
  const gCOLUMN_PRICE = 5 ;
  const gCOLUMN_NAME = 6;
  const gCOLUMN_PHONE = 7;
  const gCOLUMN_ADDRESS = 8;
  const gCOLUMN_MESSAGE = 9;
  const gCOLUMN_STATUS = 10;
  const gCOLUMN_ACTION = 11;
  // Khai báo biến mảng hằng số chứa danh sách tên các thuộc tính
  var gOrderListColumns = ["orderId","loaiPizza", "kichCo","idLoaiNuocUong","idVourcher","thanhTien","hoTen","soDienThoai","diaChi","loiNhan","trangThai","action"]
  //biến lưu thông tin tất cả đơn hàng
  var gAllOrders = [];
  //biến lưu tất cả loại nước uống
  var gDrinkList = [];
  //link server chứa thông tin orders
  const gORDERS_URL = "http://42.115.221.44:8080/devcamp-pizza365/orders";
  //link server chứa thông tin loại nước uống
  const gDRINK_LIST_URL = "http://42.115.221.44:8080/devcamp-pizza365/drinks";
  //link server chứa thông tin VOUCHER
  const gVOUCHER_URL =  "http://42.115.221.44:8080/devcamp-voucher-api/voucher_detail/";
  // Biến toàn cục để lưu trữ id đang được update or delete
  var gId;
  // Biến toàn cục để lưu trữ order id đang được update or delete
  var gOrderId;
  //mảng kích cỡ
  var gSize = [
    {
      value:"S",
      typeName: "S"
    },
    {
      value: "M",
      typeName: "M"
    },
    {
      value: "L",
      typeName: "L"
    }
  ];
  //mảng pizza type
  var gPizzaType = [
    {
      value: "seafood",
      typeName: "Hải Sản"
    },
    {
      value: "bacon",
      typeName: "Thịt hun khói"
    },
    {
      value: "hawaii",
      typeName: "Hawaii"
    }
  ];
  //mảng status
  var gStatus = [
    {
      value:"open",
      typeName: "Open"
    },
    {
      value: "cancel",
      typeName: "Đã huỷ"
    },
    {
      value: "confirmed",
      typeName: "Đã xác nhận"
    }
  ];

  // Khai báo biến hằng số
  const gNOT_SELECT_TYPE = "NOT_SELECT_TYPE"; // giá trị (value) khi chưa chọn loại pizza
  const gNOT_SELECT_KICH_CO = "NOT_SELECT_KICH_CO"; // giá trị (value) khi chưa chọn kích cỡ
  const gNOT_SELECT_DRINK = "NOT_SELECT_DRINK"; // giá trị (value) khi chưa chọn nước uống
  const gNOT_SELECT_STATUS = "NOT_SELECT_STATUS"; // giá trị (value) khi chưa chọn nước uống
  // Khai báo DataTable & mapping collumns
  var gOrderTable = $("#order-table").DataTable( {
    // Khai báo các cột của datatable
    "columns" : [
        { "data" : gOrderListColumns[gCOLUMN_ORDER_ID] },
        { "data" : gOrderListColumns[gCOLUMN_PIZZA_TYPE] },
        { "data" : gOrderListColumns[gCOLUMN_COMBO_SIZE] },
        { "data" : gOrderListColumns[gCOLUMN_DRINK] },
        { "data" : gOrderListColumns[gCOLUMN_VOUCHER_ID] },
        { "data" : gOrderListColumns[gCOLUMN_PRICE] },
        { "data" : gOrderListColumns[gCOLUMN_NAME] },
        { "data" : gOrderListColumns[gCOLUMN_PHONE] },
        { "data" : gOrderListColumns[gCOLUMN_ADDRESS] },
        { "data" : gOrderListColumns[gCOLUMN_MESSAGE] },
        { "data" : gOrderListColumns[gCOLUMN_STATUS] },
        { "data" : gOrderListColumns[gCOLUMN_ACTION] }
      ],
        
    
      "columnDefs": [ 
      // Định nghĩa lại cột loại pizza
          {
              "targets": gCOLUMN_PIZZA_TYPE,
              "render": function(data){
                for (let bI = 0; bI < gPizzaType.length; bI++){
                    if (data.toLowerCase() == gPizzaType[bI].value){ 
                    return gPizzaType[bI].typeName
                    } 
                } 
              }
          },
      
      // Định nghĩa lại cột loại nước uống
          {
              "targets": gCOLUMN_DRINK,
              "render": function(data){
                for (let bI = 0; bI<gDrinkList.length; bI++){
                    if (data == gDrinkList[bI].maNuocUong){ 
                    return gDrinkList[bI].tenNuocUong
                    } 
                } 
              }
          },
      // Định nghĩa lại cột trạng thái
          {
              "targets": gCOLUMN_STATUS,
              "render": function(data){
                for (let bI = 0; bI<gStatus.length; bI++){
                    if (data.toLowerCase() == gStatus[bI].value){ 
                    return gStatus[bI].typeName
                    } 
                } 
              }
          },
      // Định nghĩa lại cột ACTION
          {
              targets: gCOLUMN_ACTION,
              className: "text-center",
              defaultContent: `
              <i class="far fa-edit btn-edit"></i>
              <i class="fas fa-trash btn-delete" data-toggle='modal'></i>
              `
          },
      
      ],
      autoWidth: false
  });
  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  $(document).ready(function(){
      onLoadPaging();
      //gán sự kiện filter
      $("#btn-filter-order").on("click",function(){
      onBtnFilterClick();
      })
      // 2 - C: gán sự kiện Create - Thêm mới order
      $("#btn-add-order").on("click", function() {
          onBtnAddNewOrderClick();
      });
      // 3 - U: gán sự kiện Update - Sửa 1 order
      $("#order-table").on("click", ".btn-edit", function(){
          onBtnEditClick(this);
      });
      // 4 - D: gán sự kiện Delete - xóa 1 order
      $("#order-table").on("click", ".btn-delete", function(){ 
          onIconDeleteOrderClick(this);
      });
      $("#btn-create-order").on("click", function() {
          onBtnCreateOrderClick();
       });
      $("#btn-update-order").on("click", function(){
          onBtnUpdateOrderClick();
      });
      $("#btn-confirm-delete-order").on("click", function(){ 
          onBtnConfirmDeleteOrderClick();
      });
  });
  
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  function onLoadPaging(){
      "use strict"; 
      getAllOrders(); 
      getAllDrinks();
      // 1 - R: Read / Load user to DataTable
      loadDataToOrderTable(gAllOrders);
      //load các trường select trên các form
      loadDataToSelectPizzaType(gPizzaType);
      loadDataToSelectPizzaTypeCreateModal(gPizzaType)
      loadDataToSelectPizzaTypeUpdateModal(gPizzaType)
      loadDataToSelectStatus(gStatus)
      loadDataToSelectStatusCreateModal(gStatus)
      loadDataToSelectStatusUpdateModal(gStatus)
      loadDataToSelectKichCoCreateModal(gSize)
      loadDataToSelectKichCoUpdateModal(gSize)
  }
  // Hàm xử lý khi click nút filter
  function onBtnFilterClick(){
      "use strict";
      console.log("Filter");
      var vObjectFilter = {
        gPizzaTypeId : "",
        gStatus:""
      }

      // Bước 1: Thu thập dữ liệu từ select
      getDataFromSelect(vObjectFilter);
      console.log(vObjectFilter);
      // Bước 2: Kiểm tra dữ liệu - bỏ qua

      // Bước 3: Lọc dữ liệu
      var vResultFilter = filterData(vObjectFilter);
      console.log(vResultFilter);
      // Bước 4: Hiển thị dữ liệu lên Datatable
      displayOnDatatable(vResultFilter);
    }
  // Hàm xử lý sự kiện khi nút Thêm mới được click
  function onBtnAddNewOrderClick() {
      // hiển thị modal trắng lên
      $("#create-order-modal").modal("show");
  }

  //hàm xử lý sự kiện click nút create order
  function onBtnCreateOrderClick(event){
      "use strict";
      // khai báo đối tượng chứa order data
      var vOrderObj = {
          kichCo: "",
          duongKinh: "",
          suon: "",
          salad: "",
          loaiPizza: "",
          idVourcher: "",
          idLoaiNuocUong: "",
          soLuongNuoc: "",
          hoTen: "",
          thanhTien: "",
          email: "",
          soDienThoai: "",
          diaChi: "",
          loiNhan: ""
      }
      //B1: thu thập dữ liệu
      getOrderDataCreate(vOrderObj);
      console.log("thu thap thong tin" )
      console.log(vOrderObj)
      //B2: Validate insert
      var vIsOrderValidate = validateAddData(vOrderObj);        
      var vIsEmailValid = isEmailValid(vOrderObj);        
      if (vIsOrderValidate==true && vIsEmailValid==true) {
          // B3: insert user
          postOrderApi(vOrderObj);
          //B4: xử lý front-end 
          //gọi api lấy danh sách order
          getAllOrders(); 
          // load lại vào bảng (table)
          loadDataToOrderTable(gAllOrders);
          resetCreateUserForm();
          $("#create-order-modal").modal("hide"); //ẩn modal form create order
      } 
  }
 
  //hàm xử lý sự kiện click icon sửa
  function onBtnEditClick(paramButtonElement){
      "use strict";
      console.log("Button Edit Click!!!");
      var vRowClick = $(paramButtonElement).closest("tr"); //xác định tr chứa nút bấm đc click
      var vTable = $("#order-table").DataTable(); //tạo biến truy xuất đến datatable
      var vDataRow = vTable.row(vRowClick).data(); //lấy dữ liệu của hàng dữ liệu chứa nút bấm được click
      gOrderId = vDataRow.orderId;
      gId = vDataRow.id;
      //console.log("orderID = " + gId );
      $('#update-select-kich-co option:not(:selected)').attr('disabled', true);
      $('#update-select-loai-pizza option:not(:selected)').attr('disabled', true);
      $('#update-select-nuoc-uong option:not(:selected)').attr('disabled', true);
     showUpdateOrderModal(vDataRow);
  }
  //hàm xử lý sự kiện click nút update order
  function onBtnUpdateOrderClick(){
      "use strict";
     // khai báo đối tượng chứa user data 
      var vOrderObj = {
          trangThai:""
      }
      //B1: thu thập dữ liệu
      getOrderDataUpdate(vOrderObj);
      console.log(vOrderObj)
      console.log("orderID = " + gId)
      // B2: Validate update không có 
      // B3: update order
          updateOrderById(vOrderObj,gId);
          // B4: xử lý front-end
          //load lại bảng
          getAllOrders(); 
          loadDataToOrderTable(gAllOrders);
          resetUpdateOrderModalForm(); // xóa trắng modal
          $("#update-order-modal").modal("hide"); //ẩn modal form update user
  }
  // Hàm xử lý sự kiện khi icon delete order trên bảng được click
  function onIconDeleteOrderClick(paramButtonElement){
      "use strict";
      var vRowClick = $(paramButtonElement).closest("tr"); //xác định tr chứa nút bấm đc click
      var vTable = $("#order-table").DataTable(); //tạo biến truy xuất đến datatable
      var vDataRow = vTable.row(vRowClick).data(); //lấy dữ liệu của hàng dữ liệu chứa nút bấm được click
      // lưu thông tin id của order đang được delete vào biến toàn cục
      gId = vDataRow.id;
      // hiển thị modal confirm delete lên
      $("#delete-order-modal").modal("show");
  }
  //hàm xử lý sự kiện click nút confirm delete order
  function onBtnConfirmDeleteOrderClick(){
      "use strict";
      // B1: thu thập dữ liệu (ko có)
      // B2: validate (ko có)
      // B3: xóa order
      $.ajax({
          async: false,
          url: gORDERS_URL+ "/" + gId,
          type: "DELETE",
          success: function(res){
              console.log(res);
              // B4: xử lý, hiển thị trên front-end
              alert("Đã xóa đơn hàng thành công!");
          },
          error: function(error){
              alert(error.responseText);
          }
      }); 
      //load lại bảng
      getAllOrders();  
      loadDataToOrderTable(gAllOrders);
      $("#delete-order-modal").modal("hide"); //ẩn modal form delete user
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  //hàm đổ dữ liệu vào select kích cỡ create modal
  function loadDataToSelectKichCoCreateModal(paramObject){
    "use strict";
    // Thêm option mặc định
    $('#add-select-kich-co').append($('<option>', {
        value: "NOT_SELECT_KICH_CO",
        text: "Chọn kích cỡ"
    }));
    // Thêm các option từ dữ liệu
    for(var bI = 0; bI < paramObject.length; bI++){
      $('#add-select-kich-co').append($('<option>', {
        value: paramObject[bI].value,
        text: paramObject[bI].typeName
      }));
    }      
  }
  //hàm đổ dữ liệu vào select kích cỡ update modal
  function loadDataToSelectKichCoUpdateModal(paramObject){
    "use strict";
    // Thêm option mặc định
    $('#update-select-kich-co').append($('<option>', {
        value: "NOT_SELECT_KICH_CO",
        text: "Chọn kích cỡ"
    }));
    // Thêm các option từ dữ liệu
    for(var bI = 0; bI < paramObject.length; bI++){
      $('#update-select-kich-co').append($('<option>', {
        value: paramObject[bI].value,
        text: paramObject[bI].typeName
      }));
    }      
  }
  // Hàm đổ dữ liệu vào filter select
  function loadDataToSelectPizzaType(paramObject){
    "use strict";
    // Thêm option mặc định
    $('#gPizzaTypeSelect').append($('<option>', {
        value: "NOT_SELECT_TYPE",
        text: "=== Chọn loại Pizza ==="
    }));
    // Thêm các option từ dữ liệu
    for(var bI = 0; bI < paramObject.length; bI++){
      $('#gPizzaTypeSelect').append($('<option>', {
        value: paramObject[bI].value,
        text: paramObject[bI].typeName
      }));
    }      
  }
  //hàm đổ dữ liệu vào select pizza type trên create modal
  function loadDataToSelectPizzaTypeCreateModal(paramObject){
      "use strict";
    // Thêm option mặc định
    $('#add-select-loai-pizza').append($('<option>', {
        value: "NOT_SELECT_TYPE",
        text: "Chọn loại Pizza"
    }));
    // Thêm các option từ dữ liệu
    for(var bI = 0; bI < paramObject.length; bI++){
      $('#add-select-loai-pizza').append($('<option>', {
        value: paramObject[bI].value,
        text: paramObject[bI].typeName
      }));
    }      
  }
  //hàm đổ dữ liệu vào select pizza type trên update modal
  function loadDataToSelectPizzaTypeUpdateModal(paramObject){
      "use strict";
    // Thêm option mặc định
    $('#update-select-loai-pizza').append($('<option>', {
        value: "NOT_SELECT_TYPE",
        text: "Chọn loại Pizza"
    }));
    // Thêm các option từ dữ liệu
    for(var bI = 0; bI < paramObject.length; bI++){
      $('#update-select-loai-pizza').append($('<option>', {
        value: paramObject[bI].value,
        text: paramObject[bI].typeName
      }));
    }      
  }
  // Hàm đổ dữ liệu vào filter status
  function loadDataToSelectStatus(paramObject){
    "use strict";
    // Thêm các option từ dữ liệu
    for(var bI = 0; bI < paramObject.length; bI++){
      $('#gStatusSelect').append($('<option>', {
        value: paramObject[bI].value,
        text: paramObject[bI].typeName
      }));
    }      
  }
  // Hàm đổ dữ liệu vào status trên create modal
  function loadDataToSelectStatusCreateModal(paramObject){
    "use strict";
    // Thêm các option từ dữ liệu
    for(var bI = 0; bI < paramObject.length; bI++){
      $('#add-select-trang-thai').append($('<option>', {
        value: paramObject[bI].value,
        text: paramObject[bI].typeName
      }));
    }      
  }
   // Hàm đổ dữ liệu vào status trên update modal
   function loadDataToSelectStatusUpdateModal(paramObject){
    "use strict";
    // Thêm các option từ dữ liệu
    for(var bI = 0; bI < paramObject.length; bI++){
      $('#update-select-trang-thai').append($('<option>', {
        value: paramObject[bI].value,
        text: paramObject[bI].typeName
      }));
    }      
  }
  //Hàm gọi API lấy danh sách order
  function getAllOrders(){
      "use strict";
      $.ajax({
          async: false,
          url: gORDERS_URL,
          type: "GET",
          dataType: "json",
          success: function(res){
              // lấy response trả về và gán cho biến gAllOrders
              gAllOrders = res;
          },
          error: function(error){
              console.log(error.responseText);
          }
      }) 
  }
  //hàm load all drinks
  function getAllDrinks(){
      $.ajax({
      async: false,
      url: gDRINK_LIST_URL,
      type: "GET",
      dataType: 'json',
      success: function(responseObject){
          gDrinkList = responseObject
        //load drink to select
          loadDrinkSelectCreateModal(gDrinkList);
          loadDrinkSelectUpdateModal(gDrinkList)
      },
      error: function(error){
        console.assert(error.responseText);
      }
    })
  }
  /**  Load order to DataTable
  * in: order array
  * out: order table has data
  */  
  function loadDataToOrderTable(paramObjectOrders) {
      gOrderTable.clear();
      gOrderTable.rows.add(paramObjectOrders);
      gOrderTable.draw();
  }
   //hàm load list đồ uống lên create modal
   function loadDrinkSelectCreateModal(paramDrinkList){
      for (var bIndex = 0; bIndex < paramDrinkList.length; bIndex++){
      $("#add-select-nuoc-uong").append($('<option>',{
          value: paramDrinkList[bIndex].maNuocUong,
          text: paramDrinkList[bIndex].tenNuocUong
      }));
  }
  }
  //hàm load list đồ uống lên update modal
  function loadDrinkSelectUpdateModal(paramDrinkList){
      for (var bIndex = 0; bIndex < paramDrinkList.length; bIndex++){
      $("#update-select-nuoc-uong").append($('<option>',{
          value: paramDrinkList[bIndex].maNuocUong,
          text: paramDrinkList[bIndex].tenNuocUong
      }));
  }
  }
  // hàm thu thập dữ liệu để create order
  function getOrderDataCreate(paramOrderObj){
      "use strict";
      var vDonGia = $("#add-inp-don-gia").val();
      paramOrderObj.kichCo = $("#add-select-kich-co").val();
      paramOrderObj.duongKinh = $("#add-inp-duong-kinh").val();
      paramOrderObj.suon = $("#add-inp-suon-nuong").val();
      paramOrderObj.salad = $("#add-inp-salad").val();
      paramOrderObj.soLuongNuoc = $("#add-inp-so-luong-nuoc").val();
      paramOrderObj.loaiPizza = $("#add-select-loai-pizza").val();
      paramOrderObj.idVourcher = $("#add-inp-voucher-id").val();
      paramOrderObj.thanhTien = getPriceAfterDiscount(paramOrderObj.idVourcher,vDonGia );
      paramOrderObj.idLoaiNuocUong = $("#add-select-nuoc-uong").val();
      paramOrderObj.hoTen = $("#add-inp-ho-ten").val();
      paramOrderObj.email = $("#add-inp-email").val();
      paramOrderObj.soDienThoai = $("#add-inp-so-dien-thoai").val();
      paramOrderObj.diaChi = $("#add-inp-dia-chi").val();
      paramOrderObj.loiNhan = $("#add-inp-loi-nhan").val();
      paramOrderObj.trangThai = $("#add-inp-trang-thai").val();
  }
  // hàm validate data khi add
  function validateAddData(paramOrderObj){
      "use strict";
      if(paramOrderObj.kichCo == gNOT_SELECT_KICH_CO){
          alert("Bạn cần chọn kích cỡ");
          return false;
      };
      if(paramOrderObj.loaiPizza== gNOT_SELECT_TYPE){
          alert("Bạn cần chọn loại pizza");
          return false;
      };
      if(paramOrderObj.idVourcher != "" && isNaN(paramOrderObj.idVourcher)){
          alert("Voucher ID phải là số");
          return false;
      };
      if(paramOrderObj.idLoaiNuocUong == gNOT_SELECT_DRINK){
          alert("Bạn cần chọn nước uống");
          return false;
      };
      if(paramOrderObj.hoTen == ""){
          alert("Bạn cần nhập họ tên");
          return false;
      };
      if(paramOrderObj.soDienThoai == ""){
          alert("Bạn cần nhập số điện thoại");
          return false;
      };
      if(paramOrderObj.diaChi == ""){
          alert("Bạn cần nhập địa chỉ");
          return false;
      };
      return true;
  }
  //hàm kiểm tra email
  function isEmailValid (paramCustomerInfoObj){
      if(paramCustomerInfoObj.email==""){
          return true;
      }
      else if (paramCustomerInfoObj.email.indexOf("@")>0 && paramCustomerInfoObj.email.indexOf("@")<paramCustomerInfoObj.email.length-1){
          return true;
          console.log("Email hợp lệ")
      } alert("Email không hợp lệ")
  }
  //hàm gọi API create order
  function postOrderApi(paramOrderObj){
      "use strict";
      $.ajax({
          async: false,
          url: gORDERS_URL,
          type: "POST",
          data: JSON.stringify(paramOrderObj),
          contentType: "application/json",
          success: function(res){
              console.log(res);
              alert("Thêm order thành công!");
          },
          error: function(error){
              alert(error.responseText);
          }
      });
  }
 
  // hàm xóa trắng form create user
  function resetCreateUserForm() {
      $("#add-select-kich-co").val(gNOT_SELECT_KICH_CO);
      $("#add-inp-duong-kinh").val("");
      $("#add-inp-suon-nuong").val("");
      $("#add-inp-salad").val("");
      $("#add-inp-so-luong-nuoc").val("");
      $("#add-inp-don-gia").val("");
      $("#add-select-loai-pizza").val(gNOT_SELECT_TYPE);
      $("#add-inp-voucher-id").val("");
      $("#add-select-nuoc-uong").val(gNOT_SELECT_DRINK);
      $("#add-inp-ho-ten").val("");
      $("#add-inp-email").val("");
      $("#add-inp-so-dien-thoai").val("");
      $("#add-inp-dia-chi").val("");
      $("#add-inp-loi-nhan").val("");
      $("#add-inp-trang-thai").val("open");
  }
  
  //hàm gán giá trị khi kích cỡ combo được chọn create modal
  function assignValueBaseOnCombo(element){
      if (element == "S"){
          $("#add-inp-duong-kinh").val(20);
          $("#add-inp-suon-nuong").val(2);
          $("#add-inp-salad").val("200g");
          $("#add-inp-so-luong-nuoc").val(2);
          $("#add-inp-don-gia").val(150000) ;
      }
      else if (element == "M"){
          $("#add-inp-duong-kinh").val(25);
          $("#add-inp-suon-nuong").val(4);
          $("#add-inp-salad").val("300g");
          $("#add-inp-so-luong-nuoc").val(3);
          $("#add-inp-don-gia").val(200000)
      }
      else if (element == "L"){
          $("#add-inp-duong-kinh").val(30);
          $("#add-inp-suon-nuong").val(8);
          $("#add-inp-salad").val("500g");
          $("#add-inp-so-luong-nuoc").val(4);
          $("#add-inp-don-gia").val(250000)
      }
      }
  
  //hàm tìm phần trăm discount khi biết mã giảm giá
  function getPercentageDiscount(paramVoucher){
var vDiscountPercentage = 0;

     if(paramVoucher!="") {
   //gọi API lấy % giảm giá
      $.ajax({
      async: false,
      url: gVOUCHER_URL + paramVoucher,
      type: "GET",
      dataType: 'json',
      success: function(responseObject){
          vDiscountPercentage = responseObject.phanTramGiamGia
        //tính giá sau khi giảm
        console.log(vDiscountPercentage)
        return vDiscountPercentage 
      },
      error: function(error){
          alert("Mã giảm giá không tồn tại");
      console.log("Không tìm thấy voucher " + vXmlHttp.responseText);
      }
    })
    return vDiscountPercentage
  } 
  return vDiscountPercentage
}
  //hàm tính giá sau khi discount
  function getPriceAfterDiscount(paramVoucherInp,paramDonGia){
      var vDiscountPercentage = Number(getPercentageDiscount(paramVoucherInp));
      var vPriceVND = paramDonGia;
      var vPriceAfterDiscount=0
      if (vDiscountPercentage == 0){   
                          
          return vPriceVND;
      } else {vPriceAfterDiscount = vPriceVND * (1-(vDiscountPercentage)/100); 
          return vPriceAfterDiscount;
      }
          
  }  
  //hàm hiện modal update cùng thông tin của order
  function showUpdateOrderModal(paramDataRow){
      "use strict";
      console.log(paramDataRow);
      $("#update-order-modal").modal("show"); //hiện update modal
      "use strict";
      $("#update-inp-order-id").val(paramDataRow.orderId);
      $("#update-select-kich-co").val(paramDataRow.kichCo);
      assignValueBaseOnComboUpdateModal(paramDataRow.kichCo);
      $("#update-inp-duong-kinh").val(paramDataRow.duongKinh);
      $("#update-inp-suon-nuong").val(paramDataRow.suon);
      $("#update-inp-salad").val(paramDataRow.salad);
      $("#update-inp-so-luong-nuoc").val(paramDataRow.soLuongNuoc);
      $("#update-select-loai-pizza").val((paramDataRow.loaiPizza).toLowerCase());
      $("#update-inp-voucher-id").val(paramDataRow.idVourcher);
      $("#update-inp-thanh-tien").val(paramDataRow.thanhTien);
      $("#update-select-nuoc-uong").val(paramDataRow.idLoaiNuocUong );
      $("#update-inp-ho-ten").val(paramDataRow.hoTen);
      $("#update-inp-email").val(paramDataRow.email );
      $("#update-inp-so-dien-thoai").val(paramDataRow.soDienThoai);
      $("#update-inp-dia-chi").val(paramDataRow.diaChi );
      $("#update-inp-loi-nhan").val(paramDataRow.loiNhan);
      $("#update-inp-trang-thai").val(paramDataRow.trangThai );
  }
  //hàm gán giá trị đơn giá khi kích cỡ combo được chọn update modal
  function assignValueBaseOnComboUpdateModal(element){
      if (element == "S"){
          $("#update-inp-don-gia").val(150000) ;
      }
      else if (element == "M"){
          $("#update-inp-don-gia").val(200000)
      }
      else if (element == "L"){
          $("#update-inp-don-gia").val(250000)
      }
      }
  //hàm thu thập dữ liệu nhập trên form update order
  function getOrderDataUpdate(paramOrderObj){
      "use strict";
      paramOrderObj.trangThai = $("#update-select-trang-thai").val();
  }
  // hàm thực hiện update order
  function updateOrderById(paramOrderObj,paramId){
      "use strict";
      $.ajax({
          async: false,
          url: gORDERS_URL +"/" + paramId,
          type: "PUT",
          data: JSON.stringify(paramOrderObj),
          contentType:  "application/json;charset=UTF-8",
          success: function(res){
              console.log(res);
              alert("Đã update user thành công!");
          },
          error: function(error){
              alert(error.responseText);
          }
      });
  }
  // hàm xóa trắng form update user
  function resetUpdateOrderModalForm(){
      "use strict";
      $("#update-select-kich-co").val(gNOT_SELECT_KICH_CO);
      $("#update-inp-duong-kinh").val("");
      $("#update-inp-suon-nuong").val("");
      $("#update-inp-salad").val("");
      $("#update-inp-so-luong-nuoc").val("");
      $("#update-inp-don-gia").val("");
      $("#update-select-loai-pizza").val(gNOT_SELECT_TYPE);
      $("#update-inp-voucher-id").val("");
      $("#update-select-nuoc-uong").val(gNOT_SELECT_DRINK);
      $("#update-inp-ho-ten").val("");
      $("#update-inp-email").val("");
      $("#update-inp-so-dien-thoai").val("");
      $("#update-inp-dia-chi").val("");
      $("#update-inp-loi-nhan").val("");
  }
  //hàm thu thập thông tin trên select
  function getDataFromSelect(paramObjectFilter){
    "use strict";
    paramObjectFilter.gPizzaTypeId = $("#gPizzaTypeSelect option:selected").val();
    paramObjectFilter.gStatus = $("#gStatusSelect option:selected").val();
  }
  //hàm filter dữ liệu
  function filterData(paramObjectFilter){
    "use strict";

    var vFilter = gAllOrders.filter(function(item){
      return (((item.loaiPizza).toLowerCase() == (paramObjectFilter.gPizzaTypeId).toLowerCase() || paramObjectFilter.gPizzaTypeId == gNOT_SELECT_TYPE)
          && ((item.trangThai).toLowerCase() == (paramObjectFilter.gStatus).toLowerCase() ))
      
          
    })

    return vFilter;
  }
  // Hàm đổ dữ liệu vào datatable
  function displayOnDatatable(paramObjectData){
    "use strict"
    var vTable = $('#order-table').DataTable();
    vTable.clear();
    vTable.rows.add(paramObjectData);
    vTable.draw();
  }
</script>

</html>
